# This file is auto-generated by the CDP protocol generator.
# Do not edit this file manually as your changes will be overwritten.
# Generated from Chrome DevTools Protocol specifications.

"""CDP DOMDebugger Domain Types"""

from typing_extensions import Literal
from typing_extensions import NotRequired, TypedDict

from typing import TYPE_CHECKING

if TYPE_CHECKING:
    from ..dom.types import BackendNodeId
    from ..runtime.types import RemoteObject
    from ..runtime.types import ScriptId

DOMBreakpointType = Literal["subtree-modified", "attribute-modified", "node-removed"]
"""DOM breakpoint type."""



CSPViolationType = Literal["trustedtype-sink-violation", "trustedtype-policy-violation"]
"""CSP Violation type."""



class EventListener(TypedDict):
    """Object event listener."""

    type: "str"
    """`EventListener`'s type."""
    useCapture: "bool"
    """`EventListener`'s useCapture."""
    passive: "bool"
    """`EventListener`'s passive flag."""
    once: "bool"
    """`EventListener`'s once flag."""
    scriptId: "ScriptId"
    """Script id of the handler code."""
    lineNumber: "int"
    """Line number in the script (0-based)."""
    columnNumber: "int"
    """Column number in the script (0-based)."""
    handler: "NotRequired[RemoteObject]"
    """Event handler function value."""
    originalHandler: "NotRequired[RemoteObject]"
    """Event original handler function value."""
    backendNodeId: "NotRequired[BackendNodeId]"
    """Node the listener is added to (if any)."""
