# This file is auto-generated by the CDP protocol generator.
# Do not edit this file manually as your changes will be overwritten.
# Generated from Chrome DevTools Protocol specifications.

"""CDP Log Domain Types"""

from typing import List
from typing_extensions import NotRequired, TypedDict

from typing import TYPE_CHECKING

if TYPE_CHECKING:
    from ..network.types import RequestId
    from ..runtime.types import RemoteObject
    from ..runtime.types import StackTrace
    from ..runtime.types import Timestamp

class LogEntry(TypedDict):
    """Log entry."""

    source: "str"
    """Log entry source."""
    level: "str"
    """Log entry severity."""
    text: "str"
    """Logged text."""
    category: "NotRequired[str]"
    timestamp: "Timestamp"
    """Timestamp when this entry was added."""
    url: "NotRequired[str]"
    """URL of the resource if known."""
    lineNumber: "NotRequired[int]"
    """Line number in the resource."""
    stackTrace: "NotRequired[StackTrace]"
    """JavaScript stack trace."""
    networkRequestId: "NotRequired[RequestId]"
    """Identifier of the network request associated with this entry."""
    workerId: "NotRequired[str]"
    """Identifier of the worker associated with this entry."""
    args: "NotRequired[List[RemoteObject]]"
    """Call arguments."""



class ViolationSetting(TypedDict):
    """Violation configuration setting."""

    name: "str"
    """Violation type."""
    threshold: "float"
    """Time threshold to trigger upon."""
